﻿using System;
using System.Collections.Generic;
using System.Text;

namespace OsakaUniv.RIWL.Koudo.Writimation
{
    public class PointData
    {
        private float x_;
        private float y_;
        private long time_;
        private PointData linkedPointData_;
        private bool selected_;

        public PointData()
        {
            this.Clear();
        }

        public PointData(
            float x,
            float y,
            long time)
        {
            this.Clear();

            this.x_ = x;
            this.y_ = y;
            this.time_ = time;
        }

        #region property
        //
        //  property
        //

        public PointData LinkedPointData
        {
            get { return this.linkedPointData_; }
            set { this.linkedPointData_ = value; }
        }

        public bool Selected
        {
            get { return this.selected_; }
            set { this.selected_ = value; }
        }

        public long Time
        {
            get { return this.time_; }
            set { this.time_ = value; }
        }

        public float X
        {
            get { return this.x_; }
            set { this.x_ = value; }
        }

        public float Y
        {
            get { return this.y_; }
            set { this.y_ = value; }
        }

        #endregion  //  property

        #region method
        //
        //  method
        //

        public void Clear()
        {
            this.x_ = float.NaN;
            this.y_ = float.NaN;
            this.time_ = 0L;
            this.linkedPointData_ = null;
            this.selected_ = false;
        }

        public void CopyTo(
            PointData dst)
        {
            dst.X = this.x_;
            dst.Y = this.y_;
            dst.Time = this.time_;
            dst.LinkedPointData = this.linkedPointData_;
            dst.Selected = this.selected_;
        }

        public bool ComparePointTo(
            PointData data)
        {
            return ((data.X == this.x_) && (data.Y == this.y_));
        }

        public void MoveTo(
            float offsetX,
            float offsetY)
        {
            this.x_ += offsetX;
            this.y_ += offsetY;
        }

        public bool Valid()
        {
            return (this.x_ != float.NaN) && (this.y_ != float.NaN);
        }

        #endregion  //  method
    }
}
