﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace OsakaUniv.RIWL.Koudo.Writimation
{
    public partial class frmText : Form
    {
        private string textData_;
        private Font fontDisplay_;
        private Color textColor_;

        public frmText()
        {
            InitializeComponent();

            textData_ = "";
            fontDisplay_ = txtDisplay.Font;
            textColor_ = Color.LightGray;
        }

        #region property
        //
        //  property
        //

        public Color TextColor
        {
            get { return this.textColor_; }
            set 
            { 
                this.textColor_ = value;
                txtDisplay.ForeColor = this.textColor_;
            }
        }

        public string TextData
        {
            get { return this.textData_; }
            set
            {
                this.textData_ = value;
                txtDisplay.Text = this.textData_;
            }
        }

        public Font FontDisplay
        {
            get { return this.fontDisplay_; }
            set
            {
                this.fontDisplay_ = value;
                txtDisplay.Font = this.fontDisplay_;
            }
        }

        #endregion  //  property

        private void btnCancel_Click(object sender, EventArgs e)
        {
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            this.textData_ = txtDisplay.Text;
            this.fontDisplay_ = txtDisplay.Font;
            this.textColor_ = picFontColor.BackColor;
        }

        private void btnFont_Click(object sender, EventArgs e)
        {
            FontDialog dlg = new FontDialog();
            dlg.Font = this.fontDisplay_;
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                this.fontDisplay_ = dlg.Font;
                txtDisplay.Font = this.fontDisplay_;
            }
            txtDisplay.Focus();
        }

        private void frmText_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.T:
                    if (e.Control)
                    {
                        btnFont_Click(null, null);
                    }
                    break;
            }
        }

        private void frmText_Load(object sender, EventArgs e)
        {
            this.Text = Application.ProductName + "[Background text]";
            txtDisplay.Text = this.textData_;
            txtDisplay.Font = this.fontDisplay_;
            txtDisplay.ForeColor = this.textColor_;
            picFontColor.BackColor = this.textColor_;
        }

        private void picFontColor_Click(object sender, EventArgs e)
        {
            ColorDialog dlg = new ColorDialog();
            dlg.Color = picFontColor.BackColor;
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                picFontColor.BackColor = dlg.Color;
                txtDisplay.ForeColor = picFontColor.BackColor;
            }
        }
    }
}
